/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_insn.h 2178 2011-07-23 09:58:56Z ertl-honda $
 */


/*
 *  ¸ü̿Υ饤ؿARM-Mѡ
 */

#ifndef CORE_INSN_H
#define CORE_INSN_H

#include <arm_m.h>

/*
 *  ꤬ѹ뤳Ȥ򥳥ѥ뤿Υޥ
 */
#define ARM_MEMORY_CHANGED __memory_changed()

/*
 *  FAULTMASKΥå
 */
Inline void
set_faultmask(void){
	__disable_fiq();
}

/*
 *  FAULTMASKΥꥢ
 */
Inline void
clear_faultmask(void){
	__enable_fiq();
}

/*
 *  PRIMASKΥå
 */
Inline void
set_primask(void){
	__disable_irq();
}

/*
 *  PRIMASKΥꥢ
 */
Inline void
clear_primask(void){
	__enable_irq();
}

/*
 *  BASEPRIΥå
 */
Inline void
set_basepri(uint32_t val){
	register uint32_t basepri __asm("basepri");
	basepri = val;
}

/*
 *  BASEPRIμ
 */
Inline uint32_t
get_basepri(void){
	register uint32_t basepri __asm("basepri");
	return basepri;
}

/*
 *  CONTROLΥå
 */
Inline void
set_control(uint32_t val){
	register uint32_t control __asm("control");
	control = val;
	/*
	 *  control쥸åȸˤisbɬ
	 *  [ARMv7-M Architecture Reference Manaual(DDI0403B) A3-37]
	 */
	__isb(0xf);
}

/*
 *  CONTROLμ
 */
Inline uint32_t
get_control(void){
	register uint32_t control __asm("control");
	return(control);
}

/*
 *  ơ쥸IPSRˤθͤɽФ
 */
Inline uint32_t
get_ipsr(void)
{
	register uint32_t ipsr __asm("ipsr");
	return(ipsr);
}

#endif /* CORE_INSN_H */
