/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * åȰ¸⥸塼STBEEѡ
 */
#include "kernel_impl.h"
#include <sil.h>
#include "stbee.h"
#include "stm32f.h"
#include "usart.h"

/*
 * åȰ¸
 */
void
target_initialize(void)
{
	/*
	 *  ץåå(RCC)ν
	 */
	/* HSIͭ */
	sil_orw((void*)RCC_CR, CR_HSI_ON);

	/* SW, HPRE, PPRE1, PPRE2, ADCPRE,MCOΥꥢ */
	sil_andw((void*)RCC_CFGR, 0xF8FF0000);

	/* HSEON, CSSON, PLLON Υꥢ */
	sil_andw((void*)RCC_CR, 0xFEF6FFFF);

	/* HSEBYP Υꥢ */
	sil_andw((void*)RCC_CR, 0xFFFBFFFF);

	/* PLLSRC, PLLXTPRE, PLLMUL, USBPRE/OTGFSPRE Υꥢ */
	sil_andw((void*)RCC_CFGR, 0xFF80FFFF);

	/*
	 *  72Mhz
	 */
	/* HSEͭ */
	sil_orw((void*)RCC_CR, CR_HSE_ON);

	/* HSEͭԤ */
	while ((sil_rew_mem((void*)RCC_CR) & CR_HSE_RDY) == 0) ;

	/* FLASH ROMΥץեåХåեͭ */
	sil_orw((void*)FLASH_ACR, ACR_PRFTBE);

	/* FLASH ROM2wait */
	sil_andw((void*)FLASH_ACR, ~ACR_LATENCY_MASK);
	sil_orw((void*)FLASH_ACR, ACR_LATENCY_TWO);

	/* HCLK = SYSCLK, PCLK2 = HCLK, PCLK1 = HCLK/2  */
	sil_orw((void*)RCC_CFGR, 0x00 | (0x00 << 11) | (0x04 << 8));

	/* PLLCLK = 12MHz x 6 = 72MHz, HSE as PLL clock */
	sil_andw((void*)RCC_CFGR, ~(CFGR_PLL_SRC|CFGR_PLL_XTPRE|CFGR_PLLMUL_MASK));
	sil_orw((void*)RCC_CFGR, CFGR_PLL_SRC | PLLMUL << 18);

	/* PLLͭ */
	sil_orw((void*)RCC_CR, CR_PLL_ON);

	/* PLLͭԤ */
	while ((sil_rew_mem((void*)RCC_CR) & CR_PLL_RDY) == 0) ;

	/* PLL򥷥ƥ९å */
	sil_andw((void*)RCC_CFGR, ~CFGR_SW_MASK);
	sil_orw((void*)RCC_CFGR, CFGR_SW_PLL);
  
	/* PLLΥƥ९åԤ */
	while ((sil_rew_mem((void*)RCC_CFGR) & CFGR_SWS_MASK) != (CFGR_SW_PLL << 2)) ;

	/*
	 *  åװ¸ν
	 */
	chip_initialize();

	/*
	 *  ڥեͭ
	 */
	sil_orw((void*)RCC_APB2ENR, APB2ENR_USART1_EN | APB2ENR_IOPA_EN |
			APB2ENR_IOPD_EN | APB2ENR_AFIO_EN);
#if (TNUM_PORT >= 2)
	sil_orw((void*)RCC_APB2ENR, APB2ENR_IOPD_EN);
	sil_orw((void*)RCC_APB1ENR, APB1ENR_USART2_EN);
#endif
	/*
	 *  I/OݡȤν
	 */
	/* USART1(RX)  ץ륢å */
	set_cr_mode(GPIOA_BASE, 10, MODE_INPUT);
	set_cr_cnf(GPIOA_BASE, 10, CNF_IN_FLOATING);

	/* USART1(TX) */
	set_cr_mode(GPIOA_BASE, 9, MODE_OUTPUT_50MHZ);
	set_cr_cnf(GPIOA_BASE, 9, CNF_OUT_AF_PP);

#if (TNUM_PORT >= 2)
	/* USART2(RX)  ץ륢å */
	set_cr_mode(GPIOD_BASE, 6, MODE_INPUT);
	set_cr_cnf(GPIOD_BASE, 6, CNF_IN_FLOATING);

	/* USART2(TX) */
	set_cr_mode(GPIOD_BASE, 5, MODE_OUTPUT_50MHZ);
	set_cr_cnf(GPIOD_BASE, 5, CNF_OUT_AF_PP);

	/* USART2ݡȤΥޥåסPD5,6 */
	sil_orw((void*)AFIO_MAPR, MAPR_USART2_REMAP);
#endif

	/* LEDݡ(PD.4) */
	set_cr_mode(GPIOD_BASE, 4, MODE_OUTPUT_50MHZ);
	set_cr_cnf(GPIOD_BASE, 4, CNF_OUT_GP_PP);

	/*
	 *  СʡѤΥꥢ
	 */
	usart_init(SIO_PORTID);
}


/*
 *  ܡɾLEDON/OFF
 */
void
stbee_led_on(void){
	sil_andw((void*)(GPIOD_BASE + 0x0c), ~(1 << 4));
}

void
stbee_led_off(void){
	sil_orw((void*)(GPIOD_BASE + 0x0c), (1 << 4));
}

/*
 * åȰ¸λ
 */
void
target_exit(void)
{
	/* åװ¸νλ */
	chip_exit();
	while(1);
}

/*
 * ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}
